<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SendAckRequestProcessor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">SendAckRequestProcessor.java</span></div><h1>SendAckRequestProcessor.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.io.Flushable;
import java.io.IOException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.RequestProcessor;

public class SendAckRequestProcessor implements RequestProcessor, Flushable {
<span class="fc" id="L32">    private static final Logger LOG = LoggerFactory.getLogger(SendAckRequestProcessor.class);</span>
    
    Learner learner;

<span class="fc" id="L36">    SendAckRequestProcessor(Learner peer) {</span>
<span class="fc" id="L37">        this.learner = peer;</span>
<span class="fc" id="L38">    }</span>

    public void processRequest(Request si) {
<span class="pc bpc" id="L41" title="1 of 2 branches missed.">        if(si.type != OpCode.sync){</span>
<span class="fc" id="L42">            QuorumPacket qp = new QuorumPacket(Leader.ACK, si.hdr.getZxid(), null,</span>
                null);
            try {
<span class="fc" id="L45">                learner.writePacket(qp, false);</span>
<span class="nc" id="L46">            } catch (IOException e) {</span>
<span class="nc" id="L47">                LOG.warn(&quot;Closing connection to leader, exception during packet send&quot;, e);</span>
                try {
<span class="nc bnc" id="L49" title="All 2 branches missed.">                    if (!learner.sock.isClosed()) {</span>
<span class="nc" id="L50">                        learner.sock.close();</span>
                    }
<span class="nc" id="L52">                } catch (IOException e1) {</span>
                    // Nothing to do, we are shutting things down, so an exception here is irrelevant
<span class="nc" id="L54">                    LOG.debug(&quot;Ignoring error closing the connection&quot;, e1);</span>
<span class="nc" id="L55">                }</span>
<span class="fc" id="L56">            }</span>
        }
<span class="fc" id="L58">    }</span>
    
    public void flush() throws IOException {
        try {
<span class="fc" id="L62">            learner.writePacket(null, true);</span>
<span class="nc" id="L63">        } catch(IOException e) {</span>
<span class="nc" id="L64">            LOG.warn(&quot;Closing connection to leader, exception during packet send&quot;, e);</span>
            try {
<span class="nc bnc" id="L66" title="All 2 branches missed.">                if (!learner.sock.isClosed()) {</span>
<span class="nc" id="L67">                    learner.sock.close();</span>
                }
<span class="nc" id="L69">            } catch (IOException e1) {</span>
                    // Nothing to do, we are shutting things down, so an exception here is irrelevant
<span class="nc" id="L71">                    LOG.debug(&quot;Ignoring error closing the connection&quot;, e1);</span>
<span class="nc" id="L72">            }</span>
<span class="fc" id="L73">        }</span>
<span class="fc" id="L74">    }</span>

    public void shutdown() {
        // Nothing needed
<span class="fc" id="L78">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>